%      Deklaratv Programozs 4. gyakorlat 2010.10.25 s 2010.10.27
%     Prolog programozs: listk, feltteles szerkezetek hasznlata
%		                MEGOLDSOK
% ---------------------------------------------------------------


% 1. feladat

% fogyo_prefix(L, P): P az L nem res szmlista lehet leghosszabb olyan prefixuma 
% (kezdszelete), amely szigoran monoton cskken.

% Feltteles szerkezettel.
fogyo_prefix1([X|L], [X|P]) :-
	(   L = [Y|_], X > Y ->  fogyo_prefix1(L, P)
	;   P = []
	).

% Ugyanez vgval.
fogyo_prefix2([X,Y|L], P) :-
	X > Y, !, P = [X|P1], fogyo_prefix2([Y|L], P1).
fogyo_prefix2([X|_], [X]).

% Ugyanez "hacker" megoldssal, append megoldssorendje szmit
fogyo_prefix3(L, P) :-
	append(P, R, L),
	last(P, X),
	(   R = []
	;   R = [Y|_], X =< Y
	),
	!.

% Egy kicsit egyszerbb "hacker" megolds
fogyo_prefix4(L, P) :-
	append(P, R, L),
	last(P, X),
	\+ (R = [Y|_], X > Y),
	!.


% 2. feladat
% insert(+RL0, +Elem, ?RL): Az RL (nem felttlenl szigoran monoton) 
% nv szmlista gy ll el, hogy az RL0 szigoran nv szmlistba
% beszrjuk az Elem szmot,

insert([X|L0], E, L) :-
	E > X, !, L = [X|L1], insert(L0, E, L1).
insert(L0, E, [E|L0]).

insert_z([X|L0], E, L) :-
	E > X, !, L = [X|L1], insert_z(L0, E, L1).
insert_z([X|L0], E, [E,X|L0]) :-
	E =< X.
insert_z([], E, [E]).


% 3. feladat

x_fx([], 0).
x_fx([X|_], N) :-
	aux_x_fx(X, N).

aux_x_fx(a, 1).
aux_x_fx(b, 2).

% 4. feladat

x_gx([], 0).
x_gx([X|_], N) :-
	aux_x_gx(X, N).

aux_x_gx(a, N) :- !, N =1.
aux_x_gx(b, N) :- !, N =2.
aux_x_gx(_, 3).


% 5. feladat

%    % novelt(+Kif, ?Kif1): Kif1 ugyanolyan Prolog kifejezs mint Kif, csak
%    % minden egsz szm helyett az eggyel nagyobb szm szerepel benne.

%    Plda: ?- novelt(f(1, X, 2, [3,4.0]), Kif1).   
%    vlasz:	Kif1 = f(2, X, 3, [4,4.0])

novelt(Kif, NKif) :-
	integer(Kif), !, NKif is Kif+1.
novelt(Kif, NKif) :-
	compound(Kif), !,
	Kif =.. [F|Args],
	lista_novelt(Args, NArgs),
	NKif =.. [F|NArgs].
novelt(Kif, Kif).

lista_novelt([], []).
lista_novelt([K|L], [NK|NL]) :-
	novelt(K, NK),
	lista_novelt(L, NL).

% 6. feladat

% resze_egesz(X, I): Az X kifejezs rszkifejezse az I egsz szm.
resze_egesz(X, I) :-
	(   integer(X) -> X = I
	;   compound(X),
	    X =.. [_|Args],
	    member(A, Args),
	    resze_egesz(A, I)
	).

% 7. feladat

% resze(Kif, R): Kif rszkifejezse az R
resze(Kif, Kif).
resze(Kif, R) :-
	compound(Kif),
	Kif =.. [_|Args],
	member(A, Args),
	resze(A, R).

% 8. feladat

erteke(x, V, E) :- !, E = V.
erteke(N, _V, E) :- number(N), !, E = N.
erteke(Kif, V, E) :-
	Kif =.. [F|Argk],
	erteke_lista(Argk, V, Ek),
	EKif =.. [F|Ek],
	E is EKif.

erteke_lista([], _, []).
erteke_lista([K|Kk], V, [E|Ek]) :-
	erteke(K, V, E),
	erteke_lista(Kk, V, Ek).

