%      Deklaratv Programozs 5. gyakorlat 2010.11.08 s 2010.11.10
%     Prolog programozs:  "univ", algoritmusok, minta-vizsgafeladat
%		                MEGOLDSOK
% ---------------------------------------------------------------


% 1. feladat

% resze_egesz(X, I): Az X kifejezs rszkifejezse az I egsz szm.
resze_egesz(X, I) :-
	(   integer(X) -> X = I
	;   compound(X),
	    X =.. [_|Args],
	    member(A, Args),
	    resze_egesz(A, I)
	).

% 2. feladat

% resze(Kif, R): Kif rszkifejezse az R
resze(Kif, Kif).
resze(Kif, R) :-
	compound(Kif),
	Kif =.. [_|Args],
	member(A, Args),
	resze(A, R).

% 3. feladat

erteke(x, V, E) :- !, E = V.
erteke(N, _V, E) :- number(N), !, E = N.
erteke(Kif, V, E) :-
	Kif =.. [F|Argk],
	erteke_lista(Argk, V, Ek),
	EKif =.. [F|Ek],
	E is EKif.

erteke_lista([], _, []).
erteke_lista([K|Kk], V, [E|Ek]) :-
	erteke(K, V, E),
	erteke_lista(Kk, V, Ek).


erteke2(x, V, E) :- !, E = V.
erteke2(N, _V, E) :- number(N), !, E = N.
erteke2(Kif, V, E) :-
	functor(Kif, F, N),
	functor(EKif, F, N),
	(   foreacharg(A, Kif),
	    foreacharg(EA, EKif),
	    param(V)
	do  erteke2(A, V, EA)
	),
	E is EKif.

% 4. feladat

% Az L pozitv egszeket tartalmaz   %                                           
% lista balrl lthat elemeinek      %                                           
% szma VC.			      %                                           
viscnt(L, VC) :-       		      %  int viscnt(list L) {                     
    viscnt(L, 0, VC,		      %    int VC = 0;                            
           0).			      %    int MV = 0;                            
				      %  					 
% viscnt(L, VC0, VC, MV) :- Az L      %                                           
% listban (VC-VC0) darab MV-nl      %                                           
% hatrozottan nagyobb balrl 	      %                                           
% lthat elem van.                   %  loop:                                                    
viscnt([], VC0, VC, _) :- VC = VC0.   %    if (empty(L)) return VC;               
viscnt(L0, VC0, VC, MV0) :-	      %                                           
    L0 = [H|L1],		      %    { int H = head(L), L = tail(L);        
    (   H > MV0 		      %      if (H > MV)                          
    ->  VC1 is VC0+1, MV1 = H	      %         { VC += 1; MV = H; }              
    ;   VC1 = VC0, MV1 = MV0	      %    }                                      
    ), 				      %                                           
    viscnt(L1, VC1, VC, MV1).         %    goto loop;                             
				      %  }                                        

% 5. feladat

szimmetrikus(Kif) :-
	(   compound(Kif) ->
	    functor(Kif, _, N),
	    szimmetrikus_arg(1, N, Kif)
	;   true
	).

szimmetrikus_arg(I, J, Kif) :-
	(   I >= J -> true
	;   arg(I, Kif, A), arg(J, Kif, B), A == B,
	    I1 is I+1, J1 is J-1,
	    szimmetrikus_arg(I1, J1, Kif)
	).

% 6. feladat

% szimmetrikus_resze(Kif, R): Kif rszkifejezse az R
szimmetrikus_resze(Kif, Kif) :- szimmetrikus(Kif).
szimmetrikus_resze(Kif, R) :-
	compound(Kif),
	Kif =.. [_|Args],
	member(A, Args),
	szimmetrikus_resze(A, R).
